Option Explicit
'
' Data Access constants
'    
'
'   
'   "db..."    =   (DataBase)
'   "tbd..."   =   (TableDef)
'   "tbl..."   =  (Table)
'   "dns..."   =   (DynaSet)
'   "sns..."   =   (SnapShot)
'   "fld..."   =  (Field)
'   "ind..."   =  (Index)
'   "qdf..."   =  (QueryDef)
'

' Option argument values (CreateDynaset, etc)
'    ( DynaSet, )
Global Const DB_DENYWRITE = &H1
Global Const DB_DENYREAD = &H2
Global Const DB_READONLY = &H4
Global Const DB_APPENDONLY = &H8
Global Const DB_INCONSISTENT = &H10
Global Const DB_CONSISTENT = &H20
Global Const DB_SQLPASSTHROUGH = &H40

' SetDataAccessOption
'     
Global Const DB_OPTIONINIPATH = 1

' Field Attributes
'  
Global Const DB_FIXEDFIELD = &H1
Global Const DB_VARIABLEFIELD = &H2
Global Const DB_AUTOINCRFIELD = &H10
Global Const DB_UPDATABLEFIELD = &H20

' Field Data Types
'   
Global Const DB_BOOLEAN = 1
Global Const DB_BYTE = 2
Global Const DB_INTEGER = 3
Global Const DB_LONG = 4
Global Const DB_CURRENCY = 5
Global Const DB_SINGLE = 6
Global Const DB_DOUBLE = 7
Global Const DB_DATE = 8
Global Const DB_TEXT = 10
Global Const DB_LONGBINARY = 11
Global Const DB_MEMO = 12

' TableDef Attributes
'   
Global Const DB_ATTACHEXCLUSIVE = &H10000
Global Const DB_ATTACHSAVEPWD = &H20000
Global Const DB_SYSTEMOBJECT = &H80000002
Global Const DB_ATTACHEDTABLE = &H40000000
Global Const DB_ATTACHEDODBC = &H20000000

' ListTables TableType
'   -  
Global Const DB_TABLE = 1
Global Const DB_QUERYDEF = 5

' ListTables Attributes (for QueryDefs)
'   -  ( )
Global Const DB_QACTION = &HF0
Global Const DB_QCROSSTAB = &H10
Global Const DB_QDELETE = &H20
Global Const DB_QUPDATE = &H30
Global Const DB_QAPPEND = &H40
Global Const DB_QMAKETABLE = &H50

' ListIndexes IndexAttributes values
'   -   
Global Const DB_UNIQUE = 1
Global Const DB_PRIMARY = 2
Global Const DB_PROHIBITNULL = 4
Global Const DB_IGNORENULL = 8

' ListIndexes FieldAttributes value
'   -   
'For each field in Index
'    
Global Const DB_DESCENDING = 1

' CreateDatabase and CompactDatabase Language constants
'    / 
Global Const DB_LANG_GENERAL = ";LANGID=0x0809;CP=1252;COUNTRY=0"
Global Const DB_LANG_SPANISH = ";LANGID=0x040A;CP=1252;COUNTRY=0"
Global Const DB_LANG_DUTCH = ";LANGID=0x0413;CP=1252;COUNTRY=0"
'VB3 and Access 1.1 Databases
Global Const DB_LANG_SWEDFIN = ";LANGID=0x040C;CP=1252;COUNTRY=0"
'VB3 and Access 1.1 Databases
Global Const DB_LANG_NORWDAN = ";LANGID=0x0414;CP=1252;COUNTRY=0"
'VB3 and Access 1.1 Databases
Global Const DB_LANG_ICELANDIC = ";LANGID=0x040F;CP=1252;COUNTRY=0"
'Access 1.0 Databases only
Global Const DB_LANG_NORDIC = ";LANGID=0x041D;CP=1252;COUNTRY=0"

' CreateDatabase and CompactDatabase options
'   / 
'Microsoft Access Version 1.0
Global Const DB_VERSION10 = 1
'Make database encrypted
Global Const DB_ENCRYPT = 2
'Decrypt database while compacting
Global Const DB_DECRYPT = 4

' Collating order values
'   
'Sort by EFGPI rules (English, French, German, etc.)
Global Const DB_SORTGENERAL = 256
'Sort by Spanish rules
Global Const DB_SORTSPANISH = 258
'Sort by Dutch rules
Global Const DB_SORTDUTCH = 259
'Sort by Swedish, Finnish rules
Global Const DB_SORTSWEDFIN = 260
'Sort by Norwegian, Danish rules
Global Const DB_SORTNORWDAN = 261
'Sort by Icelandic rules
Global Const DB_SORTICELANDIC = 262
'Sort by Paradox international rules
Global Const DB_SORTPDXINTL = 4096
'Sort by Paradox Swedish, Finnish rules
Global Const DB_SORTPDXSWE = 4097
'Sort by Paradox Norwegian, Danish rules
Global Const DB_SORTPDXNOR = 4098
'Sort rules are undefined or unknown
Global Const DB_SORTUNDEFINED = -1

'
'   
Global Const DB_SORT_AU = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
Global Const DB_SORT_AL = "abcdefghijklmnopqrstuvwxyz"
Global Const DB_SORT_RU = "Ũ"
Global Const DB_SORT_RL = ""
'
Type FieldRW
  fBOOLEAN  As Integer
  fBYTE As Integer
  fINTEGER  As Integer
  fLONG As Long
  fCURRENCY As Currency
  fSINGLE As Single
  fDOUBLE As Double
  fDATE As Variant
  fTEXT As String
  fBINARY As String
  fMEMO As String
End Type

Sub ErrorDB (iErrC, iMode As Integer)
  '   
  '     
  '
  ' 3219 - Can't perform operation; it is illegal.
  ' 3020 - Update without AddNew or Edit.
  ' 3260 - Couldn't update; currently locked by user 'Admin' on machine 'L11_IFA2'.
  '
  '   
  '       
  '
  ' iErrC -   
  ' iMode -   (, , )
  '
  '    
  ' (Error),     - .
  '
  Dim sT As String
  Dim sFN As String
  Dim iFN As Integer
  '
  iFN = FreeFile
  sFN = sProgDirName + "ERROR.LOG"
  Open sFN For Append As #iFN
  Select Case iErrC
  Case 3219
    ' Write 3219 Can't perform operation; it is illegal.
    sT = "3219 -    ;  ."
    MsgBox sT, 48
    Print #iFN, sT
  Case 3020
    ' Write 3020 Update without AddNew or Edit.
    sT = "3020 - Update  AddNew  Edit."
    MsgBox sT, 48
    Print #iFN, sT
  Case 3260
    ' Write 3260 Couldn't update; currently locked
    ' by user 'Admin' on machine 'L11_IFA2'.
    sT = "3260 -   ;      ."
    MsgBox sT, 48
    Print #iFN, sT
  End Select
  Close #iFN
End Sub

Function sNullReadDB (dbD As Data, sF As String) As String
  '     
  '     
  '
  ' sNullReadDB -  
  '
  ' dbD -  Data,    
  '          
  ' sF  -   
  Dim sT As String
  '
  If IsNull(dbD.Recordset.Fields(sF).Value) Then
    sT = ""
  Else
    sT = dbD.Recordset.Fields(sF).Value
  End If
  '
  sNullReadDB = Trim$(sT)
End Function

