Option Explicit

Sub GridFormat (grdT As Grid, sFmt As String)
  '     
  '       
  Dim sT As String
  sT = grdT.Text
  sT = Format$(ValDbl(sT), sFmt)
End Sub

Sub GridKeyPress (grdT As Grid, txtT As TextBox, KeyPress As Integer)
  Dim iI As Integer
  Dim iCPos As Integer
  Dim iRPos As Integer
  '
  If KeyPress = 13 Then
    For iI = 0 To grdT.FixedCols - 1
      iCPos = iCPos + grdT.ColWidth(iI)
      iCPos = iCPos + 14 * grdT.GridLineWidth
    Next iI
    For iI = grdT.LeftCol To grdT.Col - 1
      iCPos = iCPos + grdT.ColWidth(iI)
      iCPos = iCPos + 14 * grdT.GridLineWidth
    Next iI
    txtT.Left = grdT.Left + iCPos
    '
    For iI = 0 To grdT.FixedRows - 1
      iRPos = iRPos + grdT.RowHeight(iI)
      iRPos = iRPos + 14 * grdT.GridLineWidth
    Next iI
    For iI = grdT.TopRow To grdT.Row - 1
      iRPos = iRPos + grdT.RowHeight(iI)
      iRPos = iRPos + 14 * grdT.GridLineWidth
    Next iI
    txtT.Top = grdT.Top + iRPos
    '
    txtT.Width = grdT.ColWidth(grdT.Col)
    txtT.Height = grdT.RowHeight(grdT.Row)
    txtT.Text = grdT.Text
    txtT.SelStart = Len(grdT.Text)
    grdT.Refresh
    txtT.Visible = True
    txtT.SetFocus
  End If
End Sub

Sub GridRead (grdT As Grid, sD As String)
  Dim sT As String
  Dim iH As Integer
  '
  iH = grdT.HighLight
  grdT.HighLight = False
  grdT.SelStartRow = grdT.FixedRows
  grdT.SelStartCol = grdT.FixedCols
  grdT.SelEndRow = grdT.Rows - 1
  grdT.SelEndCol = grdT.Cols - 1
  sT = grdT.Clip
  grdT.SelStartRow = grdT.Row
  grdT.SelStartCol = grdT.Col
  grdT.SelEndRow = grdT.SelStartRow
  grdT.SelEndCol = grdT.SelStartCol
  grdT.HighLight = iH
  '
  Call Replace(sT, Chr$(13), Chr$(9) + Chr$(13) + Chr$(10))
  sD = sT + Chr$(9) + Chr$(13) + Chr$(10)
End Sub

Sub GridRowColChange (grdT As Grid)
  grdT.Refresh
End Sub

Sub GridWrite (grdT As Grid, sD As String)
  Dim sT As String
  Dim iH As Integer
  '
  sT = sD
  Call Replace(sT, Chr$(9) + Chr$(13) + Chr$(10), Chr$(13))
  sT = Left$(sT, Len(sT) - 1)
  '
  iH = grdT.HighLight
  grdT.HighLight = False
  grdT.SelStartRow = grdT.FixedRows
  grdT.SelStartCol = grdT.FixedCols
  grdT.SelEndRow = grdT.Rows - 1
  grdT.SelEndCol = grdT.Cols - 1
  grdT.Clip = sT
  grdT.SelStartRow = grdT.Row
  grdT.SelStartCol = grdT.Col
  grdT.SelEndRow = grdT.SelStartRow
  grdT.SelEndCol = grdT.SelStartCol
  grdT.HighLight = iH
End Sub

Sub Text0KeyPress (grdT As Grid, T1 As TextBox, KeyPress As Integer)
  If KeyPress = 13 Then
    ' [Enter]
    KeyPress = 0
    grdT.Text = T1.Text
    T1.Visible = False
    grdT.SetFocus
  ElseIf KeyPress = 27 Then
    ' [Esc]
    KeyPress = 0
    T1.Visible = False
    grdT.SetFocus
  End If
End Sub

Sub Text0LostFocus (grdT As Grid, T1 As TextBox)
  T1.Visible = False
  grdT.Refresh
End Sub

Sub Text1KeyPress (grdT As Grid, T1 As TextBox, KeyPress As Integer)
  If KeyPress = 13 Then
    ' [Enter]
    KeyPress = 0
    grdT.Text = T1.Text
    T1.Visible = False
    grdT.SetFocus
  ElseIf KeyPress = 27 Then
    ' [Esc]
    KeyPress = 0
    T1.Visible = False
    grdT.SetFocus
  ElseIf KeyPress >= 48 And KeyPress <= 57 Then
    '  0123456789
  ElseIf KeyPress = 46 And Not (InStr(T1.Text, ".") <> 0) Then
    '  
  ElseIf KeyPress = 8 Then
    ' BackSpace
  Else
    KeyPress = 0
    Beep
  End If
End Sub

Sub Text1LostFocus (grdT As Grid, T1 As TextBox, sFrmt As String)
  Dim sT As String
  '
  If sFrmt <> "S:" Then
    sT = T1.Text
    grdT.Text = Trim$(Format$(ValDbl(sT), sFrmt))
  Else
  End If
  T1.Visible = False
  grdT.Refresh
End Sub

